/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.enterprise.wrapper;

import org.springblade.community.entity.Agency;
import org.springblade.community.feign.IAgencyClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.enterprise.entity.Enterprise;
import org.springblade.enterprise.vo.EnterpriseVO;
import org.springblade.system.feign.IDictBizClient;

import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-03-30
 */
public class EnterpriseWrapper extends BaseEntityWrapper<Enterprise, EnterpriseVO>  {

	private static IDictBizClient dictBizClient;
	private static IAgencyClient agencyClient;

	static {
		dictBizClient = SpringUtil.getBean(IDictBizClient.class);
		agencyClient = SpringUtil.getBean(IAgencyClient.class);
	}
	public static EnterpriseWrapper build() {
		return new EnterpriseWrapper();
 	}

	@Override
	public EnterpriseVO entityVO(Enterprise enterprise) {
		EnterpriseVO enterpriseVO = Objects.requireNonNull(BeanUtil.copy(enterprise, EnterpriseVO.class));
		R<String> enterpriseTypeNameR = dictBizClient.getValue("enterprise_type", enterprise.getEnterpriseType());
		enterpriseVO.setEnterpriseTypeName(enterpriseTypeNameR.getData());
		Agency agency = agencyClient.getById(enterprise.getAgencyId());
		if(agency != null){
			enterpriseVO.setAgencyName(agency.getName());
		}

		return enterpriseVO;
	}

}
